'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _operators = require('rxjs/operators');

var _daemon = require('./daemon');

var _daemon2 = _interopRequireDefault(_daemon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * Copyright 2018 ARDUINO SA (http://www.arduino.cc/)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * This file is part of arduino-create-agent-js-client.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * Copyright (c) 2018
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * Authors: Alberto Iannaccone, Stefania Mellai, Gabriele Destefanis
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * This software is released under:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * The GNU General Public License, which covers the main part of
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * arduino-create-agent-js-client
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * The terms of this license can be found at:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * https://www.gnu.org/licenses/gpl-3.0.en.html
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * You can be released from the requirements of the above licenses by purchasing
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * a commercial license. Buying such a license is mandatory if you want to modify or
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * otherwise use the software for commercial activities involving the Arduino
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * software without disclosing the source code of your own applications. To purchase
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * a commercial license, send an email to license@arduino.cc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var ChromeOsDaemon = function (_Daemon) {
  _inherits(ChromeOsDaemon, _Daemon);

  function ChromeOsDaemon(chromeExtensionId) {
    _classCallCheck(this, ChromeOsDaemon);

    var _this = _possibleConstructorReturn(this, (ChromeOsDaemon.__proto__ || Object.getPrototypeOf(ChromeOsDaemon)).call(this));

    _this.channel = null;

    _this.openChannel(function () {
      return _this.channel.postMessage({
        command: 'listPorts'
      });
    });

    _this._appConnect(chromeExtensionId);
    return _this;
  }

  /**
   * Instantiate connection and events listeners for chrome app
   */


  _createClass(ChromeOsDaemon, [{
    key: '_appConnect',
    value: function _appConnect(chromeExtensionId) {
      var _this2 = this;

      if (chrome.runtime) {
        this.channel = chrome.runtime.connect(chromeExtensionId);
        this.channel.onMessage.addListener(function (message) {
          if (message.version) {
            _this2.agentInfo = message;
            _this2.agentFound.next(true);
            _this2.channelOpen.next(true);
          } else {
            _this2.appMessages.next(message);
          }
        });
        this.channel.onDisconnect.addListener(function () {
          _this2.channelOpen.next(false);
          _this2.agentFound.next(false);
        });
      }
    }
  }, {
    key: 'handleAppMessage',
    value: function handleAppMessage(message) {
      if (message.ports) {
        this.handleListMessage(message);
      }

      if (message.supportedBoards) {
        this.supportedBoards.next(message.supportedBoards);
      }

      if (message.serialData) {
        this.serialMonitorMessages.next(message.serialData);
      }

      if (message.programmerstatus) {
        this.handleUploadMessage(message);
      }

      if (message.err) {
        this.uploading.next({ status: this.UPLOAD_ERROR, err: message.Err });
      }
    }
  }, {
    key: 'handleListMessage',
    value: function handleListMessage(message) {
      var lastDevices = this.devicesList.getValue();
      if (!_daemon2.default.devicesListAreEquals(lastDevices.serial, message.ports)) {
        this.devicesList.next({
          serial: message.ports.map(function (port) {
            return {
              Name: port.name,
              SerialNumber: port.serialNumber,
              IsOpen: port.isOpen,
              VendorID: port.vendorId,
              ProductID: port.productId
            };
          }),
          network: []
        });
      }
    }

    /**
     * Send 'close' command to all the available serial ports
     */

  }, {
    key: 'closeAllPorts',
    value: function closeAllPorts() {
      var _this3 = this;

      var devices = this.devicesList.getValue().serial;
      devices.forEach(function (device) {
        _this3.channel.postMessage({
          command: 'closePort',
          data: {
            name: device.Name
          }
        });
      });
    }

    /**
     * Send 'message' to serial port
     * @param {string} port the port name
     * @param {string} message the text to be sent to serial
     */

  }, {
    key: 'writeSerial',
    value: function writeSerial(port, message) {
      this.channel.postMessage({
        command: 'writePort',
        data: {
          name: port,
          data: message
        }
      });
    }

    /**
     * Request serial port open
     * @param {string} port the port name
     */

  }, {
    key: 'openSerialMonitor',
    value: function openSerialMonitor(port, baudrate) {
      var _this4 = this;

      if (this.serialMonitorOpened.getValue()) {
        return;
      }
      var serialPort = this.devicesList.getValue().serial.find(function (p) {
        return p.Name === port;
      });
      if (!serialPort) {
        return this.serialMonitorOpened.error(new Error('Can\'t find port ' + port));
      }
      this.appMessages.pipe((0, _operators.takeUntil)(this.serialMonitorOpened.pipe((0, _operators.filter)(function (open) {
        return open;
      })))).subscribe(function (message) {
        if (message.portOpenStatus === 'success') {
          _this4.serialMonitorOpened.next(true);
        }
        if (message.portOpenStatus === 'error') {
          _this4.serialMonitorOpened.error(new Error('Failed to open serial ' + port));
        }
      });
      this.channel.postMessage({
        command: 'openPort',
        data: {
          name: port,
          baudrate: baudrate
        }
      });
    }

    /**
     * Request serial port close
     * @param {string} port the port name
     */

  }, {
    key: 'closeSerialMonitor',
    value: function closeSerialMonitor(port) {
      var _this5 = this;

      if (!this.serialMonitorOpened.getValue()) {
        return;
      }
      var serialPort = this.devicesList.getValue().serial.find(function (p) {
        return p.Name === port;
      });
      if (!serialPort) {
        return this.serialMonitorOpened.error(new Error('Can\'t find port ' + port));
      }
      this.appMessages.pipe((0, _operators.takeUntil)(this.serialMonitorOpened.pipe((0, _operators.filter)(function (open) {
        return !open;
      })))).subscribe(function (message) {
        if (message.portCloseStatus === 'success') {
          _this5.serialMonitorOpened.next(false);
        }
        if (message.portCloseStatus === 'error') {
          _this5.serialMonitorOpened.error(new Error('Failed to close serial ' + port));
        }
      });
      this.channel.postMessage({
        command: 'closePort',
        data: {
          name: port
        }
      });
    }
  }, {
    key: 'handleUploadMessage',
    value: function handleUploadMessage(message) {
      if (this.uploading.getValue().status !== this.UPLOAD_IN_PROGRESS) {
        return;
      }
      switch (message.uploadStatus) {
        case 'message':
          this.uploading.next({ status: this.UPLOAD_IN_PROGRESS, msg: message.message });
          break;
        case 'error':
          this.uploading.next({ status: this.UPLOAD_ERROR, err: message.message });
          break;
        case 'success':
          this.uploading.next({ status: this.UPLOAD_DONE, msg: message.message });
          break;
        default:
          this.uploading.next({ status: this.UPLOAD_IN_PROGRESS });
      }
    }

    /**
     * Perform an upload via http on the daemon
     * @param {Object} target = {
     *   board: "name of the board",
     *   port: "port of the board",
     * }
     * @param {Object} data = {
     *  commandline: "commandline to execute",
     *  files: [
     *   {name: "Name of a file to upload on the device", data: 'base64data'}
     *  ],
     * }
     */

  }, {
    key: 'upload',
    value: function upload(target, data) {
      var _this6 = this;

      this.closeSerialMonitor(target.port);
      this.uploading.next({ status: this.UPLOAD_IN_PROGRESS });

      if (data.files.length === 0) {
        // At least one file to upload
        this.uploading.next({ status: this.UPLOAD_ERROR, err: 'You need at least one file to upload' });
        return;
      }

      // Main file
      var file = data.files[0];
      file.name = file.name.split('/');
      file.name = file.name[file.name.length - 1];

      var payload = {
        board: target.board,
        port: target.port,
        commandline: data.commandline,
        filename: file.name,
        data: file.data
      };

      try {
        window.oauth.token().then(function (token) {
          payload.token = token.token;
          _this6.channel.postMessage({
            command: 'upload',
            data: payload
          });
        });
      } catch (err) {
        this.uploading.next({ status: this.UPLOAD_ERROR, err: 'you need to be logged in on a Create site to upload by Chrome App' });
      }
    }
  }]);

  return ChromeOsDaemon;
}(_daemon2.default);

exports.default = ChromeOsDaemon;